unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, mysql55conn, mysql51conn, sqldb, FileUtil, Forms, Controls,
  Graphics, Dialogs, ExtCtrls, StdCtrls, IniPropStorage, winsock, regexpr;

Type
    TMyThread = class(TThread)
    private
      Status : string;
      procedure ShowStatus;
      procedure CountShow;
      procedure Exit;
    protected
      procedure Execute; override;
     public
      Constructor Create(CreateSuspended : boolean);
    end;

type

  { TForm1 }

  TForm1 = class(TForm)
    Button1: TButton;
    Button2: TButton;
    GroupBox1: TGroupBox;
    GroupBox2: TGroupBox;
    GroupBox3: TGroupBox;
    GroupBox4: TGroupBox;
    IniPropStorage1: TIniPropStorage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    LabeledEdit1: TLabeledEdit;
    LabeledEdit2: TLabeledEdit;
    LabeledEdit3: TLabeledEdit;
    LabeledEdit4: TLabeledEdit;
    LabeledEdit5: TLabeledEdit;
    LabeledEdit6: TLabeledEdit;
    LabeledEdit7: TLabeledEdit;
    Memo1: TMemo;
    MySQL55Connection1: TMySQL55Connection;
    SQLQuery1: TSQLQuery;
    SQLTransaction1: TSQLTransaction;
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var CloseAction: TCloseAction);
    procedure FormCreate(Sender: TObject);
    procedure LabeledEdit1Change(Sender: TObject);
    procedure LabeledEdit2Change(Sender: TObject);
    procedure LabeledEdit3Change(Sender: TObject);
    procedure LabeledEdit4Change(Sender: TObject);
    procedure LabeledEdit5Change(Sender: TObject);
    procedure LabeledEdit6Change(Sender: TObject);
    procedure LabeledEdit7Change(Sender: TObject);
  private
    { private declarations }
  public
    MyThread: TMyThread;
    procedure IniSave;
    procedure Counter;
    procedure funlog(str : String);
    function d_addr(IPaddr : string) : Cardinal;
    function theget(domain : string) : String;
    { public declarations }
  end;

TSockArray = record
      sock : TSocket;
      status, host,uri : string;
      port : word;
      send, recv : array [0..1023] of char;
      stat, time, size : Integer;
      end;
const
      CLOSE_SOCK=0;
      CONNECTING_SOCK=1;
      CONNECTED_SOCK=2;
      SENDED_SOCK=3;
      RECV_SOCK=4;

var
  Form1: TForm1;
  dbhost,dbport,dbbase,dbuser,dbpass,
  site,bot,total,cpl,balance : String;
  cnt : Integer;

implementation

{$R *.lfm}

{ TForm1 }

procedure TMyThread.Execute;
VAR
  id,domain,temp : String;
begin
     while (not Terminated) do
     begin
          try
          Form1.MySQL55Connection1.Connected:=true;
          except
             status := 'ошибка подключения БД!';
             Synchronize(@Showstatus);
             Synchronize(@Exit);
             Terminate;
          end;
          Form1.SQLQuery1.Close;
          Form1.SQLQuery1.SQL.Text := 'SELECT id,LOWER(site) AS domain FROM sites WHERE ready = FALSE LIMIT 1;';
          Form1.SQLQuery1.Open;
          if Form1.SQLQuery1.EOF then
          begin
               status := 'Работа завершена!';
               Synchronize(@CountShow);
               Synchronize(@Showstatus);
               Synchronize(@Exit);
               Terminate;
          end;
          id := Form1.SQLQuery1.FieldByName('id').AsString;
          domain := Form1.SQLQuery1.FieldByName('domain').AsString;
          Form1.SQLQuery1.Close;
          temp := Form1.theget(domain);

          if LeftStr(temp,1) = '2' then
          Form1.SQLQuery1.SQL.Text:='UPDATE sites SET ready = TRUE, err = FALSE, code = "200" WHERE id='+id;
          if temp = 'error' then
          Form1.SQLQuery1.SQL.Text:='UPDATE sites SET ready = TRUE, err = TRUE, code = "err" WHERE id='+id;
          if LeftStr(temp,1) = '4' then
          Form1.SQLQuery1.SQL.Text:='UPDATE sites SET ready = TRUE, err = TRUE, code = "'+temp+'"  WHERE id='+id;
          if LeftStr(temp,1) = '3' then
          Form1.SQLQuery1.SQL.Text:='UPDATE sites SET ready = TRUE, err = TRUE, code= "'+temp+'"  WHERE id='+id;
          if LeftStr(temp,1) = '5' then
          Form1.SQLQuery1.SQL.Text:='UPDATE sites SET ready = TRUE, err = TRUE, code= "'+temp+'"  WHERE id='+id;
          try
                Form1.SQLQuery1.ExecSQL;
          except
                   status := 'Ошибка записи в БД!';
                   Synchronize(@Showstatus);
                   Terminate;
          end;
          Synchronize(@CountShow);
          status := domain+' - '+temp;
          Synchronize(@Showstatus);
          Form1.MySQL55Connection1.Connected:=false;
     end;
     Synchronize(@Exit);
end;

constructor TMyThread.Create(CreateSuspended : boolean);
begin
  FreeOnTerminate := True;
  inherited Create(CreateSuspended);
end;

procedure TMyThread.exit;
begin
     Form1.Button2.Caption := 'старт';
     Form1.GroupBox1.Enabled := true;
end;

procedure TMyThread.CountShow;
begin
     inc(cnt);
     Form1.Label4.Caption := IntToStr(cnt);
     Form1.Label6.Caption := IntToStr((StrToInt(Form1.Label2.Caption) - cnt));
end;

procedure TMyThread.ShowStatus;
begin
     Form1.funlog(Status);
end;

procedure TForm1.funlog(str : String);
var
  i:Integer;
begin
   while memo1.Lines.Count>5 do
   begin
      memo1.Lines.Delete(0);
   end;
   Memo1.Lines.Add(str);
end;

procedure TForm1.Counter;
begin
     SQLQuery1.Close;
     SQLQuery1.SQL.Text := 'SELECT COUNT(*) AS total, cpl, (COUNT(*)-cpl) AS balance FROM sites,(SELECT COUNT(*) AS cpl FROM sites WHERE ready = TRUE) AS t;';
     SQLQuery1.Open;
     total := SQLQuery1.FieldByName('total').AsString;
     Label2.Caption := total;
     cpl := SQLQuery1.FieldByName('cpl').AsString;
     Label4.Caption := cpl;
     balance := SQLQuery1.FieldByName('balance').AsString;
     Label6.Caption := balance;
     SQLQuery1.Close;
end;

procedure TForm1.IniSave;
begin
     if GroupBox1.Enabled then
     begin
     IniPropStorage1.StoredValue['dbhost'] := dbhost;
     IniPropStorage1.StoredValue['dbport'] := dbport;
     IniPropStorage1.StoredValue['dbbase'] := dbbase;
     IniPropStorage1.StoredValue['dbuser'] := dbuser;
     IniPropStorage1.StoredValue['dbpass'] := dbpass;
     IniPropStorage1.StoredValue['site'] := site;
     IniPropStorage1.StoredValue['bot'] := bot;
     IniPropStorage1.Save;
     end;
end;

procedure TForm1.LabeledEdit1Change(Sender : TObject);
begin
     dbhost := LabeledEdit1.Text;
     IniSave;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     IniPropStorage1.Restore;
     dbhost := IniPropStorage1.StoredValue['dbhost'];
     LabeledEdit1.Text := dbhost;
     dbport := IniPropStorage1.StoredValue['dbport'];
     LabeledEdit2.Text := dbport;
     dbbase := IniPropStorage1.StoredValue['dbbase'];
     LabeledEdit3.Text := dbbase;
     dbuser := IniPropStorage1.StoredValue['dbuser'];
     LabeledEdit4.Text := dbuser;
     dbpass := IniPropStorage1.StoredValue['dbpass'];
     LabeledEdit5.Text := dbpass;
     site := IniPropStorage1.StoredValue['site'];
     LabeledEdit6.Text := site;
     bot := IniPropStorage1.StoredValue['bot'];
     LabeledEdit7.Text := bot;
     GroupBox1.Enabled := true;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
     MySQL55Connection1.HostName := dbhost;
     MySQL55Connection1.port := StrToInt(dbport);
     MySQL55Connection1.DatabaseName := dbbase;
     MySQL55Connection1.UserName := dbuser;
     MySQL55Connection1.Password := dbpass;
     try
      begin
         try
         MySQL55Connection1.Connected := true;
         except
          begin
              funlog('ошибка подключения');
              exit;
          end;
         end;
      end
     finally
        Counter;
        MySQL55Connection1.Connected := false;
        funlog('тест пройден');
     end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     If Button2.Caption = 'старт' then
     begin
          MySQL55Connection1.HostName := dbhost;
          MySQL55Connection1.port := StrToInt(dbport);
          MySQL55Connection1.DatabaseName := dbbase;
          MySQL55Connection1.UserName := dbuser;
          MySQL55Connection1.Password := dbpass;
          MySQL55Connection1.Connected := true;
          Counter;
          MySQL55Connection1.Connected := false;
          cnt := StrToInt(cpl);
          Button2.Caption := 'стоп';
          GroupBox1.Enabled := false;
          inherited;
          MyThread := TMyThread.Create(false);
     end
     else
     begin
          Button2.Caption := 'старт';
          GroupBox1.Enabled := true;
          MyThread.Terminate;
     end;
end;

procedure TForm1.FormClose(Sender: TObject; var CloseAction: TCloseAction);
begin
     if MyThread <> nil then
     MyThread.Terminate;
end;

procedure TForm1.LabeledEdit2Change(Sender: TObject);
begin
     dbport := LabeledEdit2.Text;
     IniSave;
end;

procedure TForm1.LabeledEdit3Change(Sender: TObject);
begin
     dbbase := LabeledEdit3.Text;
     IniSave;
end;

procedure TForm1.LabeledEdit4Change(Sender: TObject);
begin
     dbuser := LabeledEdit4.Text;
     IniSave;
end;

procedure TForm1.LabeledEdit5Change(Sender: TObject);
begin
     dbpass := LabeledEdit5.Text;
     IniSave;
end;

procedure TForm1.LabeledEdit6Change(Sender: TObject);
begin
     site := LabeledEdit6.Text;
     IniSave;
end;

procedure TForm1.LabeledEdit7Change(Sender: TObject);
begin
     bot := LabeledEdit7.Text;
     IniSave;
end;

function TForm1.d_addr(IPaddr : string) : Cardinal;
var
  pa: PChar;
  sa: TInAddr;
  Host: PHostEnt;
begin
  Result:=inet_addr(PChar(IPaddr));
  if Result=INADDR_NONE then
  begin
    host:=GetHostByName(PChar(IPaddr));
    if Host = nil then
      exit
    else
    begin
      pa := Host^.h_addr_list^;
      sa.S_un_b.s_b1 := pa[0];
      sa.S_un_b.s_b2 := pa[1];
      sa.S_un_b.s_b3 := pa[2];
      sa.S_un_b.s_b4 := pa[3];
      with TInAddr(sa).S_un_b do
        Result:=inet_addr(PChar(IntToStr(Ord(s_b1)) + '.' + IntToStr(Ord(s_b2)) + '.' +
        IntToStr(Ord(s_b3)) + '.' + IntToStr(Ord(s_b4))));
    end;
  end;
end;

function TForm1.theget(domain : string) : String;
var
  temp, temp2:String;
  sock : TSockArray;
  on_sock : u_Long = 1;
  off_sock : u_Long = 0;
  wfds_empty : Boolean;
  wfds : Tfdset;
  tv : Ttimeval;
  wsa : WSAData;
  addr : Tsockaddr;
  reg: TRegExpr;
  wait,read,recvwait : Boolean;
  a,b : Integer;
begin
  fillchar(sock.recv,1024,#0);
  fillchar(sock.send,1024,#0);
  WSAStartup($101,wsa);
  sock.host := domain;
  sock.port := 80;
  if sock.uri='' then sock.uri:='/';
  sock.sock:=socket(AF_INET,SOCK_STREAM,0);
  sock.time:=4;
  temp:='GET '+sock.uri+' HTTP/1.1'+#13#10+
                 'Host: '+sock.host+#13#10+
                 'Referer: http://'+site+#13#10+
                 'Connection: close'+#13#10+
                 'User-Agent: '+bot+' (+http://'+site+')'+#13#10+
                 'Accept-Encoding: gzip'+#13#10+
                 'Accept: text/html,application/xhtml+xml,application/xml;q=0.9,*/*;q=0.8'+#13#10+
                 'Cache-Control: no-cache'+#13#10#13#10;
  sock.send:=temp;
  sock.size:=length(temp);
  ioctlsocket(sock.sock,FIONBIO,on_sock);
  addr.sin_family:=AF_INET;
  addr.sin_port:=htons(sock.port);
  addr.sin_addr.s_addr:=d_addr(sock.host);
  connect(sock.sock,addr,sizeof(addr));
  sock.stat:=CONNECTING_SOCK;
  FD_ZERO(wfds);
  wfds_empty:=true;

  wait:=true;
  while wait do
  begin
    if (sock.stat=CONNECTING_SOCK) and (sock.status='') then
       begin
         FD_SET(sock.sock,wfds);
         wfds_empty:=false;
       end;
    if not wfds_empty then
    begin
      tv.tv_sec:=0;
      tv.tv_usec:=500000;
      select(0,nil,@wfds,nil,@tv);
    end;
    if (sock.stat<>CLOSE_SOCK) and (sock.status='') then
      begin
        sleep(5);
        dec(sock.time);
        if sock.time<=0 then
        begin
          sock.stat:=CLOSE_SOCK;
          sock.status:='timeout';
          ioctlsocket(sock.sock,FIONBIO,off_sock);
          closesocket(sock.sock);
        end;
      end;

      if (sock.stat=CONNECTING_SOCK) and (sock.status='') then
      begin
        if FD_ISSET(sock.sock,wfds) then
          begin
          sock.stat:=CONNECTED_SOCK;
          end;
      end;

      if (sock.stat=CONNECTED_SOCK) and (sock.status='') then
      begin
        FD_CLR(sock.sock,wfds);
        send(sock.sock,sock.send,sock.size,0);
        sock.stat:=SENDED_SOCK;
      end;

      if (sock.stat=SENDED_SOCK) and (sock.status='') then
      begin
         temp:='';
         read:=true;
         a:=0;
         b:=0;
         recvwait:=false;
         while read do
         begin
           if a=100 then read:=false;
           inc(a);
           fillchar(sock.recv,1024,#0);
           recv(sock.sock,sock.recv,1024,0);
           if sock.recv<>'' then recvwait:=true;
           if temp2<>sock.recv then
           begin
             temp2:=sock.recv;
             temp+=sock.recv;
           end
           else
           if recvwait then
           begin
                if (b=1) then
                read:=false
                else inc(b);
           end;
           sleep(30);
         end;
         sock.status:='ok';
         sock.stat:=CLOSE_SOCK;
         ioctlsocket(sock.sock,FIONBIO,off_sock);
         closesocket(sock.sock);
      end;

  wait:=false;
  if sock.status='' then wait:=true;
  end;
  WSACleanup;
  if (sock.status<>'ok') OR (temp = '') then
  begin
    result:='error';
    exit;
  end;
  reg:=TRegExpr.Create;
  reg.Expression:='([^"HTTP/1.1 "][0-9]+)';
  reg.Exec(temp);
  result:=reg.Match[0];
  reg.Free;
end;

end.

